<?php

namespace Nwb\MultiDownloaderClient;

class Watermark
{
    /**
     * @var WatermarkOption[]
     */
    private $options = [];

    public function __construct(array $options)
    {
        $this->addOptions($options);
    }

    public function addOption(WatermarkOption $option)
    {
        $this->options[] = $option;

        return $this;
    }

    public function addOptions(array $options)
    {
        foreach ($options as $option) {
            $this->addOption($option);
        }

        return $this;
    }

    public function getOptions(): array
    {
        return $this->options;
    }

    public function options(array $options)
    {
        $this->options = [];
        $this->options = $options;

        return $this;
    }

    public function toArray(): array
    {
        return array_map(function (WatermarkOption $option) {
            return array_filter([
                'url' => $option->getUrl(),
                'fallbackUrl' => $option->getFallbackUrl(),
                'width' => $option->getWidth(),
                'height' => $option->getHeight()
            ]);
        }, $this->options);
    }
}
