<?php

namespace Nwb\MultiDownloaderClient;

class WatermarkOption
{
    /**
     * @var string
     */
    private $url;

    /**
     * @var string
     */
    private $fallbackUrl;

    /**
     * @var int
     */
    private $width;

    /**
     * @var int
     */
    private $height;

    public function __construct(string $url, int $width, int $height)
    {
        $this->url = $url;
        $this->width = $width;
        $this->height = $height;
    }

    public function url(string $url)
    {
        $this->url = $url;

        return $this;
    }

    public function getUrl()
    {
        return $this->url;
    }

    public function fallbackUrl(string $fallbackUrl)
    {
        $this->fallbackUrl = $fallbackUrl;

        return $this;
    }

    public function getFallbackUrl()
    {
        return $this->fallbackUrl;
    }

    public function width(int $width)
    {
        $this->width = $width;

        return $this;
    }

    public function getWidth()
    {
        return $this->width;
    }

    public function height(int $height)
    {
        $this->height = $height;

        return $this;
    }

    public function getHeight()
    {
        return $this->height;
    }

    public function toArray(): array
    {
        return array_filter([
            'url' => $this->url,
            'fallbackUrl' => $this->fallbackUrl,
            'width' => $this->width,
            'height' => $this->height
        ]);
    }
}
